
#include "deftypes.h"
#include "raine.h"

extern int disp_x_8;

void ldraw8x8_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;
   for(yy=0; yy<8; yy++){
     dx = x+ReadWord(dy+yy*2);
     if (dx < 0 || dx > disp_x_8) {
       SPR += 8;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy]))+ dx;
     for(xx=0; xx<8; xx++){
       *line++ = ((UINT32 *)cmap)[ *SPR++ ];
     }
   }
}

void cdraw8x8_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   INT16 myx,xx,yy,dy;
   for(xx=0; xx<=15; xx++){
     dy = y-ReadWord(dx+xx*2);
     if (dy < 0 || dy > disp_x_8) {
       continue;
     }
     myx = x + xx;
     for(yy=0; yy<8; yy++){
       UINT8 *spr = &SPR[xx+8*yy];
       line = ((UINT32 *)(GameBitmap->line[dy+yy]))+myx ;
       *line = ((UINT32 *)cmap)[ *spr ];
     }
   }
}

void ldraw8x8_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=15; yy>=0; yy--){
     dx = x+ReadWord(dy+yy*2);
     if (dx < 0 || dx > disp_x_8) {
       SPR += 8;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy]))+ dx;
     for(xx=0; xx<8; xx++){
       *line++ = ((UINT32 *)cmap)[ *SPR++ ];
     }
   }
}

void cdraw8x8_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   INT16 myx,xx,yy,dy;
   for(xx=0; xx<=15; xx++){
     dy = y-ReadWord(dx+xx*2);
     if (dy < 0 || dy > disp_x_8) {
       continue;
     }
     myx = x + xx;
     for(yy=15; yy>=0; yy--){
       UINT8 *spr = &SPR[xx+8*(8-yy)];
       line = ((UINT32 *)(GameBitmap->line[dy+yy]))+myx ;
       *line = ((UINT32 *)cmap)[ *spr ];
     }
   }
}

void ldraw8x8_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=0; yy<8; yy++){
     dx = x+ReadWord(dy+yy*2);
     if (dx < 0 || dx > disp_x_8) {
       SPR += 8;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx+15;
     for(xx=0; xx<8; xx++){
       *line-- = ((UINT32 *)cmap)[ *SPR++ ];
     }
   }
}

void cdraw8x8_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   INT16 myx,xx,yy,dy;
   for(xx=15; xx>=0; xx--){
     dy = y-ReadWord(dx+xx*2);
     if (dy < 0 || dy > disp_x_8) {
       continue;
     }
     myx = x + xx;
     for(yy=0; yy<8; yy++){
       UINT8 *spr = &SPR[8-xx+8*yy];
       line = ((UINT32 *)(GameBitmap->line[dy+yy]))+myx ;
       *line = ((UINT32 *)cmap)[ *spr ];
     }
   }
}

void ldraw8x8_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=15; yy>=0; yy--){
     dx = x+ReadWord(dy+yy*2);
     if (dx < 0 || dx > disp_x_8) {
       SPR += 8;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx + 15;
      for(xx=0; xx<8; xx++){
         *line-- = ((UINT32 *)cmap)[ *SPR++ ];
      }
   }
}

void cdraw8x8_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   INT16 myx,xx,yy,dy;
   for(xx=15; xx>=0; xx--){
     dy = y-ReadWord(dx+xx*2);
     if (dy < 0 || dy > disp_x_8) {
       continue;
     }
     myx = x + xx;
     for(yy=15; yy>=0; yy--){
       UINT8 *spr = &SPR[8-xx+8*(8-yy)];
       line = ((UINT32 *)(GameBitmap->line[dy+yy]))+myx ;
       *line = ((UINT32 *)cmap)[ *spr ];
     }
   }
}

// 8x8 mapped transparent sprites

void ldraw8x8_Trans_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap,UINT8 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=0; yy<8; yy++){
     dx = x+ReadWord(dy+yy*2);
     if (dx < 0 || dx > disp_x_8) {
       SPR += 8;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx;
     for(xx=0; xx<8; xx++, SPR++){
       if(*SPR)
	 line[xx] = ((UINT32 *)cmap)[ *SPR ];
     }
   }

}

void cdraw8x8_Trans_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   INT16 myx,xx,yy,dy;
   for(xx=0; xx<=15; xx++){
     dy = y-ReadWord(dx+xx*2);
     if (dy < 0 || dy > disp_x_8) {
       continue;
     }
     myx = x + xx;
     for(yy=0; yy<8; yy++){
       UINT8 *spr = &SPR[xx+8*yy];
       if(*spr) {
	 line = ((UINT32 *)(GameBitmap->line[dy+yy]))+myx ;
	 *line = ((UINT32 *)cmap)[ *spr ];
       }
     }
   }
}

void ldraw8x8_Trans_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=15; yy>=0; yy--){
     dx = x+ReadWord(dy+yy*2);
     if (dx < 0 || dx > disp_x_8) {
       SPR += 8;
       continue;
     }
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx;
      for(xx=0; xx<8; xx++, SPR++){
         if(*SPR)
            line[xx] = ((UINT32 *)cmap)[ *SPR ];
      }
   }
}

void cdraw8x8_Trans_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   INT16 myx,xx,yy,dy;
   for(xx=0; xx<=15; xx++){
     dy = y-ReadWord(dx+xx*2);
     if (dy < 0 || dy > disp_x_8) {
       continue;
     }
     myx = x + xx;
     for(yy=15; yy>=0; yy--){
       UINT8 *spr = &SPR[xx+8*(8-yy)];
       if (*spr) {
	 line = ((UINT32 *)(GameBitmap->line[dy+yy]))+myx ;
	 *line = ((UINT32 *)cmap)[ *spr ];
       }
     }
   }
}

void ldraw8x8_Trans_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=0; yy<8; yy++){
     dx = x+ReadWord(dy+yy*2);
     if (dx < 0 || dx > disp_x_8) {
       SPR += 8;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx;
      for(xx=15; xx>=0; xx--, SPR++){
         if(*SPR)
            line[xx] = ((UINT32 *)cmap)[ *SPR ];
      }
   }
}

void cdraw8x8_Trans_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   INT16 myx,xx,yy,dy;
   for(xx=15; xx>=0; xx--){
     dy = y-ReadWord(dx+xx*2);
     if (dy < 0 || dy > disp_x_8) {
       continue;
     }
     myx = x + xx;
     for(yy=0; yy<8; yy++){
       UINT8 *spr = &SPR[8-xx+8*(yy)];
       if (*spr) {
	 line = ((UINT32 *)(GameBitmap->line[dy+yy]))+myx ;
	 *line = ((UINT32 *)cmap)[ *spr ];
       }
     }
   }
}

void ldraw8x8_Trans_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=15; yy>=0; yy--){
     dx = x+ReadWord(dy+yy*2);
     if (dx < 0 || dx > disp_x_8) {
       SPR += 8;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx;
     for(xx=15; xx>=0; xx--, SPR++){
       if(*SPR)
	 line[xx] = ((UINT32 *)cmap)[ *SPR ];
     }
   }
}

void cdraw8x8_Trans_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, UINT8 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   INT16 myx,xx,yy,dy;
   for(xx=15; xx>=0; xx--){
     dy = y-ReadWord(dx+xx*2);
     if (dy < 0 || dy > disp_x_8) {
       continue;
     }
     myx = x + xx;
     for(yy=15; yy>=0; yy--){
       UINT8 *spr = &SPR[8-xx+8*(8-yy)];
       if (*spr) {
	 line = ((UINT32 *)(GameBitmap->line[dy+yy]))+myx ;
	 *line = ((UINT32 *)cmap)[ *spr ];
       }
     }
   }
}

